' JuseOffice.vbs
'      2020/04/21
'      2020/04/26 (f[^x[X֘AC)
'      2020/05/03 (IncludẽpXY@C)
'      2020/05/09 (web̎捞݂̃ZwP)
'      2020/05/30 (pTCYݒȂǂZNVɂΉ)
'      2020/08/22 (s{bge[u֘ÃTu[`ǉ)
'      2020/09/06 (񓚏WṽTu[`ǉ)
'      2020/10/17 (f[^x[X֐ǉ)
'    Copyright (C) T. Yoshiizumi, 2020 All rights reserved.
Option Explicit
Dim g_fso, g_sho, warningFile
Dim  m_ScriptFolder, m_WbDict, m_DocDict, m_IncludeDict
Dim [GNZ], [[NubN], [[NV[g], [Z]
Dim [[h], [hLg]
Dim [f[^x[X]
Randomize  ' WFl[^

    ' O[oϐ`
Set g_fso = CreateObject("Scripting.FileSystemObject")
Set g_sho = WScript.CreateObject("WScript.Shell")
Set [GNZ] = Nothing
Set [[NubN] = Nothing
Set [[NV[g] = Nothing
Set [Z] = Nothing
Set [[h] = Nothing
Set [hLg] = Nothing
Set [f[^x[X] = Nothing
warningFile = g_fso.GetAbsolutePathName("Warning(JuseOffice).txt")
If g_fso.FileExists(warningFile) Then g_fso.DeleteFile(warningFile)

    ' o[ϐ(̂)̒`
Set m_WbDict = CreateObject("Scripting.Dictionary")
Set m_DocDict = CreateObject("Scripting.Dictionary")
Set m_IncludeDict = CreateObject("Scripting.Dictionary")
m_ScriptFolder = m_GetScriptFolder()

' -------- o[֐(̂)̒`
' --privateFunc XNvĝtH_𓾂B
Function m_GetScriptFolder()
    Dim publicFolder, juseFolder, fname, scriptFolder, scriptFile
    publicFolder = g_sho.Environment("Process").Item("PUBLIC")
    juseFolder = publicFolder & "\juse"
    fname = WScript.ScriptFullName
    If m_IncludeDict.Exists(fname) = False Then
        m_IncludeDict.Add fname, fname
    End If
    scriptFile = g_fso.GetFileName(fname)
    scriptFolder = g_fso.getParentFolderName(fname)
    If scriptFile <> "JuseOffice.vbs" Then
        fname = scriptFolder & "\JuseOffice.vbs"
        fname = Replace(fname, "\\", "\")
        If g_fso.FileExists(fname) = True Then
            m_IncludeDict.Add fname, fname
        Else
            scriptFolder = juseFolder
            fname = scriptFolder & "\JuseOffice.vbs"
            fname = Replace(fname, "\\", "\")
            If g_fso.FileExists(fname) = True Then
                m_IncludeDict.Add fname, fname
            Else
                scriptFolder = publicFolder
            End If
        End If
    End If
    m_GetScriptFolder = scriptFolder
End Function

' --privateFunc Includeœǂݍރt@C̃pXT
Function m_FindIncludePath(ByVal fname)
    Dim longName, shortName, publicFolder, juseFolder
    longName = FullPath(fname)
    shortName = g_fso.GetFileName(longName)
    If g_fso.FileExists(longName) = True Then
        m_FindIncludePath = longName
        Exit Function
    End If
    LongName = m_ScriptFolder & "\" & ShortName
    LongName = Replace(LongName, "\\", "\")
    If g_fso.FileExists(longName) = True Then
        m_FindIncludePath = longName
        Exit Function
    End If
    publicFolder = g_sho.Environment("Process").Item("PUBLIC")
    juseFolder = publicFolder & "\juse"
    LongName = juseFolder & "\" & shortName
    If g_fso.FileExists(longName) = True Then
        m_FindIncludePath = longName
        Exit Function
    End If
    LongName = publicFolder & "\" & shortName
    If g_fso.FileExists(longName) = True Then
        m_FindIncludePath = longName
        Exit Function
    End If
    m_FindIncludePath = fname
End Function

' --privateSubPara JuseOfficěxbZ[W̏o(5b)
Sub m_WarningMsg(ByVal msg, ByVal title)
    Dim fileObj
    g_sho.PopUp msg, 7, title, 4096
    Set fileObj = g_fso.OpenTextFile(warningFile, 8, True)
    fileObj.Write title & vbNewLine & msg & vbNewLine & vbNewLine
    fileObj.Close
    Set fileObj = Nothing
End Sub

' --privateFuncPara gq擾
Function m_GetMyExtName(ByVal FileName)
    If InStr(FileName, ".") = 0 Then
        m_GetMyExtName = ""
        Exit Function
    End If
    m_GetMyExtName = LCase(g_fso.GetExtensionName(FileName))
End Function

' --privateFuncPara Õ[NubNɊJĂ邩̃`FbN
Function m_SameWorkBookOpen(ByVal FileName)
    Dim targetName, wb, flag, key
    targetName = LCase(g_fso.GetFileName(FileName))
    flag = False
    For Each wb In [GNZ].WorkBooks
        If LCase(wb.Name) = targetName Then
            flag = True
        End If
    Next
    If flag = False Then
        For Each key In m_WbDict.Keys
            If LCase(g_fso.GetFileName(m_WbDict(key))) = targetName Then
                flag = True
            End If
        Next
    End If
    m_SameWorkBookOpen = flag
End Function

' --privateFuncPara ÕhLgɊJĂ邩̃`FbN
Function m_SameDocumentOpen(ByVal FileName)
    Dim targetName, doc, flag, key
    targetName = LCase(g_fso.GetFileName(FileName))
    flag = False
    For Each doc In [[h].Documents
        If LCase(doc.Name) = targetName Then
            flag = True
        End If
    Next
    If flag = False Then
        For Each key In m_DocDict.Keys
            If LCase(g_fso.GetFileName(m_DocDict(key))) = targetName Then
                flag = True
            End If
        Next
    End If
    m_SameDocumentOpen = flag
End Function

' --privateFuncPara ̃[NV[gǂmF
Function m_EmptySheet(ws)
    Dim rc
    rc = True
    If ws.UsedRange.Address <> "$A$1" Then
        rc = False
    ElseIf ws.Range("$A$1").Value <> "" Or _
            ws.Range("$A$1").Formula <> "" Then
        rc = False
    End If
    If ws.ChartObjects.Count > 0 Or ws.Shapes.Count > 0 Or _
            ws.Hyperlinks.Count > 0 Or ws.QueryTables.Count > 0 Or _
            ws.Scenarios.Count > 0 Then
        rc = False
    End If
    m_EmptySheet = rc
End Function

' --privateFuncPara ExcelRangeWorksheetIuWFNgo
Function m_PopSheet(rng)
    Dim sh
    If TypeName(rng) = "Worksheet" Then
        Set m_PopSheet = rng
        Exit Function
    End If
    On Error Resume Next
    Set sh = rng.Parent
    If Err.Number <> 0 Then
        Set sh = Nothing
        Err.Clear
    ElseIf TypeName(sh) <> "Worksheet" Then
        Set sh = Nothing
    End If
    On Error GoTo 0
    Set m_PopSheet = sh
End Function

' --privateFuncPara Access̃f[^x[XI[vẴIuWFNgԂ
Function m_DbOpenAccess(ByVal DbName)
    Dim DbPath, ExtName, ConnObj, ConnStr, CAT, n
    DbPath = FullPath(DbName)
    ExtName = m_GetMyExtName(DbPath)
    If ExtName = "mdb" Then
        ConnStr = "Provider=Microsoft.Jet.OLEDB.4.0;" & _
            "Data Source=" & DbPath & ";"
        If (g_fso.FileExists(DbPath) = False) Then
            Set CAT = CreateObject("ADOX.Catalog")
            On Error Resume Next
            Set ConnObj = CAT.Create(ConnStr)
            n = Err.Number
            Err.Clear
            On Error GoTo 0
            Set CAT = Nothing
            If n = 0 Then
                Set m_DbOpenAccess = ConnObj
                Exit Function
            End If
        Else
            Set ConnObj = CreateObject("ADODB.Connection")
            On Error Resume Next
            ConnObj.Open ConnStr
            n = Err.Number
            Err.Clear
            On Error GoTo 0
            If n = 0 Then
                Set m_DbOpenAccess = ConnObj
                Exit Function
            End If
        End If
    End If
    ConnStr = "Provider=Microsoft.ACE.OLEDB.12.0;Data Source=" & DbPath & ";"
    If (g_fso.FileExists(DbPath) = False) Then
        Set CAT = CreateObject("ADOX.Catalog")
        Set ConnObj = CAT.Create(ConnStr)
        Set CAT = Nothing
    Else
        Set ConnObj = CreateObject("ADODB.Connection")
        ConnObj.Open ConnStr
    End If
    Set m_DbOpenAccess = ConnObj
End Function

' --privateFuncPara Excelf[^x[XƂĊJ
Function m_DbOpenExcel(ByVal DbName)
    Dim DbPath, ExtName, ConnObj, ConnStr, n
    DbPath = FullPath(DbName)
    ExtName = m_GetMyExtName(DbPath)
    If ExtName = "xls" Then
        ConnStr = "Provider=Microsoft.Jet.OLEDB.4.0;" & _
            "Data Source=" & DbPath & ";" & _
            "Extended Properties=""Excel 8.0;HDR=Yes;"""
        Set ConnObj = CreateObject("ADODB.Connection")
        On Error Resume Next
        ConnObj.Open ConnStr
        n = Err.Number
        Err.Clear
        On Error GoTo 0
        If n = 0 Then
            Set m_DbOpenExcel = ConnObj
            Exit Function
        End If
    End If
    ConnStr = "Provider=Microsoft.ACE.OLEDB.12.0;" & _
        "Data Source=" & DbPath & ";" & _
        "Extended Properties=""Excel 12.0 XML;HDR=Yes;"""
    Set ConnObj = CreateObject("ADODB.Connection")
    ConnObj.Open ConnStr
    Set m_DbOpenExcel = ConnObj
End Function

' --privateFuncPara f[^x[XI[vẴIuWFNgԂ
Function m_DbOpen(ByVal DbName)
    Dim ExtName, ConnObj
    ExtName = m_GetMyExtName(DbName)
    Set ConnObj = Nothing
    If ExtName = "xls" Or ExtName = "xlsx" Then
        Set ConnObj = m_DbOpenExcel(DbName)
    ElseIf ExtName = "mdb" Or ExtName = "accdb" Then
        Set ConnObj = m_DbOpenAccess(DbName)
    End If
    Set m_DbOpen = ConnObj
End Function

' --privateFuncPara ̃t@Cɂĕ̒us
Function m_FileSubstitute(ByVal FileName, ByVal oldStr, ByVal newStr)
    Dim fileObj, myStr, fname, FileName2, res
    fname = g_fso.GetFileName(FileName)
    If g_fso.FileExists(FileName) = False Then
        FileSubstitute = "XLbv: " & fname
        Exit Function
    End If
    Set fileObj = g_fso.OpenTextFile(FileName)
    myStr = fileObj.ReadAll()
    fileObj.Close
    Set fileObj = Nothing
    If InStr(myStr, oldStr) = 0 Then
        FileSubstitute = "XLbv: " & fname
        Exit Function
    End If
    myStr = Replace(myStr, oldStr, newStr)
    FileName2 = Left(FileName, Len(FileName)-Len(fname)) & "$$$" & fname
    res = ""
    Set fileObj = g_fso.OpenTextFile(FileName2, 2, True)
    On Error Resume Next
    fileObj.Write myStr
    If Err.Number <> 0 Then
        res = fname & ": ݂Ɏs."
        Err.Clear
    End If
    On Error GoTo 0
    fileObj.Close
    Set fileObj = Nothing
    If res = "" Then
        g_fso.DeleteFile(FileName)
        g_fso.MoveFile FileName2, FileName
        res = fname & ": u܂."
    Else
        If g_fso.FileExists(FileName2) Then g_fso.DeleteFile(FileName2)
    End If
    FileSubstitute = res
End Function

' --privateFunc [NubNindex(ԍ܂͖O)𒲐ĕԂ
Function m_GetBookIndex(ByVal idx)
    Dim key, widx
    If TypeName(idx) <> "String" Then
        m_GetBookIndex = idx
        Exit Function
    End If
    If InStr(idx, "\") > 0 Then idx = g_fso.GetFileName(idx)
    If m_WbDict.Exists(idx) Then
        m_GetBookIndex = idx
        Exit Function
    End If
    widx = Null
    For Each key In m_WbDict.Keys
        If g_fso.GetFileName(m_WbDict(key)) = idx Then
            widx = key
        End If
    Next
    If IsNull(widx) = False Then
        idx = widx
    End If
    m_GetBookIndex = idx
End Function

' --privateFunc hLgindex(ԍ܂͖O)𒲐ĕԂ
Function m_GetDocIndex(ByVal idx)
    Dim key, widx
    If TypeName(idx) <> "String" Then
        m_GetDocIndex = idx
        Exit Function
    End If
    If InStr(idx, "\") > 0 Then idx = g_fso.GetFileName(idx)
    If m_DocDict.Exists(idx) Then
        m_GetDocIndex = idx
        Exit Function
    End If
    widx = Null
    For Each key In m_DocDict.Keys
        If g_fso.GetFileName(m_DocDict(key)) = idx Then
            widx = key
        End If
    Next
    If IsNull(widx) = False Then
        idx = widx
    End If
    m_GetDocIndex = idx
End Function

' --privateSubPara s{bge[uœxƍ\̏Wv\𐶐
Sub m_DegreeAndRate(ptObj, ByVal xItem, ByVal yItem, ByVal YokoTate)
    Dim countItem, percentWay, yoko, tate
    countItem = xItem
    percentWay = 6
    If IsNull(xItem) = True Then countItem = yItem
    If IsNull(countItem) = True Then Exit Sub
    If IsNull(xItem) = True Then percentWay = 7
    ptObj.DisplayNullString = True
    ptObj.NullString = "0"
    If IsNull(xItem) = False Then
        With ptObj.PivotFields(xItem)
            .Orientation = 2
            .LabelRange.Value = .Name
        End With
    End If
    If IsNull(yItem) = False Then
        With ptObj.PivotFields(yItem)
            .Orientation = 1
            .LabelRange.Value = .Name
        End With
    End If
    With ptObj.PivotFields(countItem)
        .Orientation = 4
        .Function = -4112
        .Caption = "x"
    End With
    With ptObj.PivotFields(countItem)
        .Orientation = 4
        .Function = -4112
        .Caption = "\"
        .Calculation = percentWay
        .NumberFormat = "0.0%"
    End With
    yoko = 2
    tate = 1
    If IsNull(YokoTate) Then YokoTate = yoko
    If IsNull(yItem) = True Then
        ptObj.DataPivotField.Orientation = tate
        ptObj.DataPivotField.Name = ""
    Else
        ptObj.DataPivotField.Orientation = YokoTate
    End If
End Sub

' --privateSubPara 񓚏Wv̉
Sub m_MultiAnswer(sourceSheet, newObj, ByVal xItems, ByVal yItem, ByVal itemNames, ByVal kind)
    Dim colNames, factorNames, cname, pivotSheet
    Dim pt, colLast, colNum, rowNum, startCell, rng, cmd, grandName
    Dim newSheet, newRng, startCol, startRow, count, cell, i, j
    If TypeName(newObj) = "Range" Then
        Set newSheet = newObj.Parent
        Set newRng = newObj
    ElseIf TypeName(newObj) = "Worksheet" Then
        Set newSheet = newObj
        Set newRng = newSheet.Range("A1")
    Else
        Exit Sub
    End If
    If TypeName(itemNames) = "String" Then
        itemNames = Split(itemNames)
    End If
    If TypeName(xItems) = "String" Then
        colNames = Split(xItems)
    Else
        colNames = xItems
    End If
    For Each cname In colNames
        factorNames = Array("~", cname)
        [𕶎ɕϊ] sourceSheet, cname, factorNames
    Next
    grandName = "S"
    Set pivotSheet = newSheet.Parent.Worksheets.Add(, newSheet)
    Set pt = [s{bge[ȕݒ](sourceSheet, pivotSheet)
    pt.GrandTotalName = grandName
    cmd = "[%s] pt, colNames(0), yItem"
    cmd = replace(cmd, "%s", kind)
    Execute cmd
    If TypeName(yItem) = "String" And IsNull(itemNames) = False Then _
        [s{bgACȅύX] pt.RowFields(1), itemNames
    for i = 1 To UBound(colNames)
        colNum = [̃Zon](pivotSheet).Column
        Set startCell = pivotSheet.Cells(1, colNum+1)
        Set pt = [s{bge[ȕݒ](pt.PivotCache, startCell)
        pt.GrandTotalName = grandName
        cmd = "[%s] pt, colNames(i), yItem"
        cmd = replace(cmd, "%s", kind)
        Execute cmd
        If TypeName(yItem) = "String" And IsNull(itemNames) = False Then _
            [s{bgACȅύX] pt.RowFields(1), itemNames
    Next
    Set rng = pivotSheet.Range(pivotSheet.Cells(2,1), _
        [̃Zon](pivotSheet))
    rng.Copy newRng.Offset(1)
    [[NV[g폜] pivotSheet.Name
    startCol = newRng.Column
    startRow = newRng.Row + 1
    If newSheet.Cells(startRow+1, startCol+1).Value = "x" And _
        newSheet.Cells(startRow+1, startCol+2).Value = "\" Then
        Do While True
            count = 0
            For Each cname In Array("~", "Ŝ x")
                colLast = [̃Zon](newRng.CurrentRegion).Column-2
                Set rng = newSheet.Range(newSheet.Cells(startRow, startCol+1), _
                    newSheet.Cells(startRow, colLast))
                Set cell = rng.Find(cname)
                If TypeName(cell) = "Range" Then
                    count = count + 1
                    colNum = cell.Column
                    rowNum = [̃Zon](cell.CurrentRegion).Row
                    j = colNum + 1
                    If TypeName(yItem) = "String" And _
                        cell.Offset(1,2).Value = yItem Then J = J + 1
                    newSheet.Range(cell, newSheet.Cells(rowNum, j)).Delete
                End If
            Next
            If count = 0 Then Exit Do
        Loop
    Else
        Do While True
            count = 0
            If TypeName(yItem) <> "String" Then yItem = ""
            For Each cname In Array("~", yItem, grandName)
                colLast = [̃Zon](newRng.CurrentRegion).Column-1
                Set rng = newSheet.Range(newSheet.Cells(startRow, startCol+1), _
                    newSheet.Cells(startRow, colLast))
                Set cell = rng.Find(cname)
                If TypeName(cell) = "Range" Then
                    count = count + 1
                    colNum = cell.Column
                    rowNum = [̃Zon](cell.CurrentRegion).Row
                    newSheet.Range(cell, newSheet.Cells(rowNum, colNum)).Delete
                End If
            Next
            If count = 0 Then Exit Do
        Loop
    End If
    newSheet.Cells(startRow-1, startCol+1).Value = "I"
    newSheet.Cells(startRow-1, startCol).Value = Left(kind, _
        InStr(kind, "Wv") - 1)
End Sub

' ---- XNvg̎sɂTu[`
' --subPara VBScriptt@C荞
Sub Include(ByVal FileName)
    Dim LongName, ShortName, FileObj, MyStr
    LongName = FullPath(FileName)
    ShortName = g_fso.GetFileName(LongName)
    If LCase(ShortName) = "juse.wsf" Or _
        LCase(ShortName) = "juseoffice.vbs" Then Exit Sub
    If FileName = ShortName And g_fso.FileExists(LongName) = False Then
        LongName = m_FindIncludePath(longName)
    End If
    If g_fso.FileExists(LongName) = False Then
        m_WarningMsg "'" & shortName & "' ̎荞݂Ɏs", "Include"
        Exit Sub
    End If
    If m_IncludeDict.Exists(LongName) = True Then Exit Sub
    Set FileObj = g_fso.OpenTextFile(LongName)
    MyStr = FileObj.ReadAll()
    FileObj.Close
    Set FileObj = Nothing
    ExecuteGlobal MyStr
    m_IncludeDict.Add LongName, LongName
End Sub

' --sub VBScript32bitpR}hŎs
Sub RunOn32bit
    Dim p_objWshShell, p_admArg, p_admArrayArguments
    Dim p_admWscriptCscript, p_admCommand
    Set p_objWshShell = CreateObject("Wscript.Shell")
    If p_objWshShell.Environment("Process").Item( _
      "PROCESSOR_ARCHITECTURE") <> "x86" Then
        If Not WScript.Arguments.Count = 0 Then
            For Each p_admArg In Wscript.Arguments
              p_admArrayArguments = p_admArrayArguments & _
                  " """ & p_admArg & """"
            Next
        End If
        If InStr(LCase(WScript.FullName), "wscript") > 0 Then
            p_admWscriptCscript = "WScript.exe"
        Else
            p_admWscriptCscript = "CScript.exe"
        End If
        p_admCommand = """" & p_objWshShell.Environment("Process").Item( _
            "windir") & "\SysWOW64\" & p_admWscriptCscript & """ """ & _
            WScript.ScriptFullName & """" & p_admArrayArguments
        p_objWshShell.Run p_admCommand
        WScript.Quit
    End If
End Sub

' ---- Excel֘Å֐ETu[`
' --funcPara [NubNJB[[NubN], [[NV[g]ZbgB
Function [[NubNJ](ByVal FileName)
    Dim extName, fname, bookName
    FileName = FullPath(FileName)
    extName = m_GetMyExtName(FileName)
    fname = g_fso.GetFileName(FileName)
    If extName <> "xls" And extName <> "xlsx" And extName <> "xlsm" And _
        extName <> "xlt" And extName <>"xltx" Then
        m_WarningMsg "gqsK: '" & fname & "'", "[NubNJ"
        Set [[NubNJ] = Nothing
        Exit Function
    End If
    If TypeName([GNZ]) <> "Application" Then
        On Error Resume Next
        Set [GNZ] = CreateObject("Excel.Application")  ' Excel̋N
        If Err.Number <> 0 Then
            m_WarningMsg "GNZNł܂.", "[NubNJ"
            Set [[NubNJ] = Nothing
            Err.Clear
            Exit Function
        Else
            [GNZ].Visible = True  ' Excel̏ߒԂ
        End If
        On Error GoTo 0
    End If
    If m_SameWorkBookOpen(FileName) = True Then
        bookName = g_fso.GetFileName(FileName)
        m_WarningMsg "łɓ '" & bookName & "' JĂ܂.", _
            "[NubNJ"
        Set [[NubNJ] = Nothing
        Exit Function
    End If
    If g_fso.FileExists(FileName) = True Then
        Set [[NubN] = [GNZ].WorkBooks.Open(FileName)
        m_WbDict.Add [[NubN].Name, FileName
        Set [[NV[g] = [GNZ].ActiveSheet
    Else
        Set [[NubN] = [GNZ].WorkBooks.Add
        m_WbDict.Add [[NubN].Name, FileName
        Set [[NV[g] = [GNZ].ActiveSheet
    End If
    g_sho.AppActivate [[NubN].Name & " - Excel"
    Set [[NubNJ] = [[NubN]
End Function

' --subPara [[NubN]ʂ̖OŕۑBuOtĕۑvɑ
Sub [[NubNʖŕۑ](ByVal FileName)
    Dim extName, fname, rc, oldName, newName
    FileName = FullPath(FileName)
    extName = m_GetMyExtName(FileName)
    fname = g_fso.GetFileName(FileName)
    If extName <> "xls" And extName <> "xlsx" And extName <> "xlsm" Then
        m_WarningMsg "gqsK: '" & fname & "'", "[NubNʖŕۑ"
        Exit Sub
    End If
    If g_fso.FileExists(FileName) Then
        rc = MsgBox("'" & fname & "' ㏑܂?", vbYesNo+4096, _
            "[NubNʖŕۑ")
        If rc <> 6 Then Exit Sub
        g_fso.DeleteFile(FileName)
    End If
    oldName = [[NubN].Name
        Select Case extName
        Case "xls"
            [[NubN].SaveAs FileName, -4143
        Case "xlsx"
            [[NubN].SaveAs FileName, 51
        Case "xlsm"
            [[NubN].SaveAs FileName, 52
        End Select
    newName = [[NubN].Name
    If oldName <> newName Then
        m_WbDict.Remove oldName
        m_WbDict.Add newName, FileName
    End If
End Sub

' --sub [[NubN]ۑBu㏑ۑvɑ
Sub [[NubNۑ]
    Dim oldName, newName
    If TypeName([[NubN]) <> "Workbook" Then Exit Sub
    oldName = [[NubN].Name
    newName = g_fso.GetFileName(m_WbDict(oldName))
    If oldName = newName Then
        [GNZ].DisplayAlerts = False
        [[NubN].Save
        [GNZ].DisplayAlerts = True
    Else  ' VK쐬Ȃ̂ŁuOtĕۑv
        [[NubNʖŕۑ] m_WbDict(oldName)
    End If
End Sub

' --subPara w̃[NubNBԍ܂̓ubNŎw
Sub [[NubNon](ByVal idx)
    Dim wb, wbName, bookName
    If IsNull(idx) Or IsEmpty(idx) Or idx = "" Then
        Set wb = [[NubN]
    Else
        idx = m_GetBookIndex(idx)
        On Error Resume Next
        Set wb = [GNZ].Workbooks(idx)
        If Err.Number <> 0 Then
            Set wb = Nothing
            Err.Clear
        End If
        On Error GoTo 0
    End If
    If TypeName(wb) <> "Workbook" Then Exit Sub
    wbName = wb.Name
    bookName = ""
    If TypeName([[NubN]) = "Workbook" Then bookName = [[NubN].Name
    [GNZ].DisplayAlerts = False
    wb.Close
    [GNZ].DisplayAlerts = True
    If m_WbDict.Exists(wbName) = True Then m_WbDict.Remove wbName
    If wbName = bookName Then
        If [GNZ].WorkBooks.Count > 0 Then
            Set [[NubN] = [GNZ].ActiveWorkBook
            Set [[NV[g] = [GNZ].ActiveSheet
        Else
            Set [[NubN] = Nothing
            Set [[NV[g] = Nothing
        End If
    End If
End Sub

' --sub [[NubN]
Sub [[NubN]
    [[NubNon] Null
End Sub

' --sub ׂẴ[NubN, GNZI
Sub [GNZI]
    Dim wb
    If TypeName([GNZ]) <> "Application" Then Exit Sub
    If [GNZ].WorkBooks.Count > 0 Then
        [GNZ].DisplayAlerts = False
        [GNZ].WorkBooks.Close
        [GNZ].DisplayAlerts = True
    End If
    [GNZ].Quit
    m_WbDict.RemoveAll
End Sub

' --funcPara w肳ꂽԍ܂̓ubNɂ胏[NubN؂ւ
Function [[NubN؂ւ](ByVal idx)
    Dim wb
    If TypeName([GNZ]) <> "Application" Then
        Set [[NubN؂ւ] = Nothing
        Exit Function
    End If
    idx = m_GetBookIndex(idx)
    On Error Resume Next
    Set wb = [GNZ].WorkBooks(idx)
    If Err.Number <> 0 Then
        m_WarningMsg "'" & idx & "': ؂ւł܂.", _
            "[NubN؂ւ"
        Set [[NubN؂ւ] = Nothing
        Err.Clear
        Exit Function
    End If
    On Error GoTo 0
    If wb.Name <> [[NubN].Name Then
        Set [[NubN] = wb
        Set [[NV[g] = [GNZ].ActiveSheet
    End If
    Set [[NubN؂ւ] = [[NubN]
End Function

' --funcPara w肳ꂽԍ܂̓V[gɂ胏[NV[g؂ւ
Function [[NV[g؂ւ](ByVal idx)
    Dim ws
    If TypeName([[NubN]) <> "Workbook" Then
        Set [[NV[g؂ւ] = Nothing
        Exit Function
    End If
    On Error Resume Next
    Set ws = [[NubN].WorkSheets(idx)
    If Err.Number <> 0 Then
        Set [[NV[g؂ւ] = Nothing
        Err.Clear
        Exit Function
    End If
    On Error GoTo 0
    If ws.Name <> [[NV[g].Name Then
        Set [[NV[g] = ws
    End If
    Set [[NV[g؂ւ] = [[NV[g]
End Function

' --func VɃ[NV[gǉ(Ō̃V[gɂȂ)
Function [[NV[gǉ]()
    Dim count
    If TypeName([[NubN]) <> "Workbook" Then
        Set [[NV[gǉ] = Nothing
        Exit Function
    End If
    count = [[NubN].WorkSheets.Count
    On Error Resume Next
    Set [[NV[g] = [[NubN].WorkSheets.Add(, _
        [[NubN].WorkSheets(count))
    If Err.Number <> 0 Then
        Set [[NV[g] = Nothing
        Err.Clear
    End If
    On Error GoTo 0
    Set [[NV[gǉ] = [[NV[g]
End Function

' --func ̃[NV[gIBȂƂ̓[NV[gVɒǉ
Function [̃[NV[g]()
    Dim ws, i, count
    If TypeName([[NubN]) <> "Workbook" Then
        Set [̃[NV[g] = Nothing
        Exit Function
    End If
    count = [[NubN].WorkSheets.Count
    i = 1
    Set [[NV[g] = Nothing
    Do While i <= count
        Set ws = [[NubN].WorkSheets(i)
        If ws.Visible = True And m_EmptySheet(ws) = True Then
            Set [[NV[g] = ws
            Exit Do
        End If
        i = i + 1
    Loop
    If TypeName([[NV[g]) <> "Worksheet" Then
        [[NV[gǉ]
    End If
    Set [̃[NV[g] = [[NV[g]
End Function

' --func łȂ[NV[gQzŕԂ
Function [łȂ[NV[gQ]()
    Dim wsList(), ws, count
    If TypeName([[NubN]) <> "Workbook" Then
        [łȂ[NV[gQ] = Array()
        Exit Function
    End If
    count = -1
    For Each ws In [[NubN].WorkSheets
        If ws.Visible = True And m_EmptySheet(ws) = False Then
            count = count + 1
            ReDim Preserve wsList(count)
            Set wsList(count) = ws
        End If
    Next
    If count >= 0 Then
        [łȂ[NV[gQ] = wsList
    Else
        [łȂ[NV[gQ] = Array()
    End If
End Function

' --func [NV[g̖ÖꗗԂ
Function [[NV[g̈ꗗ]()
    Dim wsList(), ws, count
    If TypeName([[NubN]) <> "Workbook" Then
        [[NV[g̈ꗗ] = Array()
        Exit Function
    End If
    count = -1
    For Each ws In [[NubN].WorkSheets
        count = count + 1
        ReDim Preserve wsList(count)
        wsList(count) = ws.Name
    Next
    [[NV[g̈ꗗ] = wsList
End Function

' --subPara ExceľxbZ[Wo͂𐧌BTrue, FalsewB
Sub [GNŽx](flag)
    If TypeName([GNZ]) <> "Application" Then Exit Sub
    [GNZ].DisplayAlerts = flag
End Sub

' --funcPara w肳ꂽSheet܂Range̍łE[̃Z𓾂
Function [̃Zon](argObj)
    Dim ws, rng, cell, addr, maxRow, maxCol
    If TypeName(argObj) = "Range" Then
        Set rng = argObj
        Set ws = rng.Parent
    ElseIf TypeName(argObj) = "Worksheet" Then
        Set ws = argObj
        Set rng = ws.UsedRange
    Else
        Set ws = [[NV[g]
        Set rng = ws.UsedRange
    End If
    If TypeName(ws) <> "Worksheet" Then
        Set [̃Zon] = Nothing
        Exit Function
    End If
    addr = rng.Address
    If Len(addr) = 4 Then
        Set cell = ws.Range(addr)
    Else
        maxRow = rng.Find("*", , -4123, , 1, 2).Row
        maxCol = rng.Find("*", , -4123, , 2, 2).Column
        Set cell = ws.Cells(maxRow, maxCol)
    End If
    Set [̃Zon] = cell
End Function

' --funcPara [[NV[g]̍łE[̃Z𓾂
Function [̃Z]()
    Set [̃Z] = [̃Zon](Null)
End Function

' --funcPara w̃[NV[g̖gp̈̐擪Z𓾂
Function [V擪̃Zon](wsObj)
    Dim ws, rng, cell, rn, addr
    If TypeName(wsObj) = "Worksheet" Then
        Set ws = wsObj
    Else
        Set ws = [[NV[g]
    End If
    If TypeName(ws) <> "Worksheet" Then
        Set [V擪̃Zon] = Nothing
        Exit Function
    End If
    Set rng = ws.UsedRange
    addr = rng.Address
    If Len(addr) = 4 Then
        Set cell = ws.Range(addr)
        If cell.Value <> "" Or cell.Formula <> "" Then
            Set cell = ws.Range(addr)
        End If
    Else
        rn = [̃Zon](rng).Row + 1
        Set cell = ws.Cells.Item(rn, 1)
    End If
    Set [V擪̃Zon] = cell
End Function

' --funcPara [[NV[g]̖gp̈̐擪Z𓾂
Function [V擪̃Z]()
    Set [V擪̃Z] = [V擪̃Zon](Null)
End Function

' --funcPara w胏[NV[g̎gp̈̐擪Z𓾂
Function [擪̃Zon](wsObj)
    Dim ws, rng, addr, cell
    If TypeName(wsObj) = "Worksheet" Then
        Set ws = wsObj
    Else
        Set ws = [[NV[g]
    End If
    If TypeName(ws) <> "Worksheet" Then
        Set [擪̃Zon] = Nothing
        Exit Function
    End If
    Set rng = ws.UsedRange
    addr = Left(rng.Address, 4)
        Set cell = ws.Range(addr)
    Set [擪̃Zon] = cell
End Function

' --funcPara [[NV[g]̎gp̈̐擪Z𓾂
Function [擪̃Z]()
    Set [擪̃Z] = [擪̃Zon](Null)
End Function

' --subPara w̃[NV[g폜Bԍ܂̓V[gŎwB
Sub [[NV[g폜](ByVal idx)
    Dim ws, targetName, currentName
    If TypeName([[NubN]) = "Nothing" Then Exit Sub
    If [[NubN].WorkSheets.Count < 2 Then
        m_WarningMsg "1̃[NV[gȂ̂ō폜ł܂.", _
            "[NV[g폜"
        Exit Sub
    End If
    On Error Resume Next
    Set ws = [[NubN].WorkSheets(idx)
    If Err.Number <> 0 Then
        m_WarningMsg "'" & idx & "' ɊY郏[NV[g܂.", _
            "[NV[g폜"
        Err.Clear
        Exit Sub
    End If
    On Error GoTo 0
    targetName = ws.Name
    currentName = [[NV[g].Name
    [GNZ].DisplayAlerts = False
    [[NubN].WorkSheets(targetName).Delete
    [GNZ].DisplayAlerts = True
    If targetName = currentName Then
        Set [[NV[g] = [GNZ].ActiveSheet
    End If
End Sub

' --subPara [[NV[g]̃Rs[Ō̃V[gƂč쐬
Function [[NV[gRs[]()
    Dim lastCount, lastSheet, ws
    If TypeName([[NV[g]) <> "Worksheet" Then
        Set [[NV[gRs[] = Nothing
        Exit Function
    End If
    lastCount = [[NubN].WorkSheets.Count
    Set lastSheet = [[NubN].WorkSheets(lastCount)
    [[NV[g].Copy , lastSheet
    Set ws = [[NubN].WorkSheets(lastCount + 1)
    Set [[NV[g] = ws
    Set [[NV[gRs[] = ws
End Function

' --subPara WebtableExcel̃[NV[gɎ荞
Sub [web̕\荞](ByVal url, ByVal tn, startCell)
    Dim ws, qt
    Set ws = [[NV[g]
    If TypeName(startCell) = "String" Then
        Set startCell = ws.Range(startCell)
    End If
    Set qt = ws.QueryTables.Add("URL;" & url, startCell)
    If tn = "" Then
        qt.WebSelectionType = 2  ' ׂĂ̕\𓾂
    Else
        qt.WebTables = tn
        qt.WebSelectionType = 3  ' tablê
    End If
    qt.WebFormatting = 3  ' xlWebFormattingNone
    qt.SaveData = False
    qt.RefreshPeriod = 0
    qt.BackgroundQuery = False
    qt.Refresh
End Sub

' --funcPara w胏[NV[g̃ZQ^u؂̕ɕϊ
Function [ZQ𕶎ɕϊon](wsObj, ByVal addressStr)
    Dim ws, rng, startCell, lastCell, cell, valStr, rn, val
    valStr = ""
    If TypeName(wsObj) = "Worksheet" Then
        Set ws = wsObj
    Else
        Set ws = [[NV[g]
    End If
    If TypeName(ws) <> "Worksheet" Then
        [ZQ𕶎ɕϊon] = valStr
        Exit Function
    End If
    If m_EmptySheet(ws) = True Then
        [ZQ𕶎ɕϊon] = valStr
        Exit Function
    End If
    If TypeName(addressStr) = "Range" Then
        addressStr = addressStr.Address
    End If
    If InStr(addressStr, ":") > 0 Then
        Set rng = ws.Range(addressStr)
    Else
        Set startCell = ws.Range(addressStr)
        Set lastCell = startCell.End(-4161)
        Set rng = ws.Range(startCell, lastCell)
    End If
    rn = 0
    For Each cell In rng
        val = cell.Value
        If rn = 0 Then
            valStr = valStr & val
            rn = cell.Row
        ElseIf cell.Row > rn Then
            valStr = valStr & vbNewLine & val
            rn = cell.Row
        Else
            valStr = valStr & vbTab & val
        End If
    Next
    [ZQ𕶎ɕϊon] = valStr
End Function

' --funcPara [[NV[g]̃ZQ^u؂̕ɕϊ
Function [ZQ𕶎ɕϊ](ByVal addressStr)
    [ZQ𕶎ɕϊ] = [ZQ𕶎ɕϊon](Null, addressStr)
End Function

' --funcPara s{bge[ũIuWFNg𐶐ĕԂ
Function [s{bge[ȕݒ](sourceArg, pivotArg)
    Dim sourceObj, pivotRng
    Dim sourceSheet, pivotSheet, wb, sourceRng, ptCache, ptObj
    Set sourceSheet = m_PopSheet(sourceArg)
    Set pivotSheet = m_PopSheet(pivotArg)
    If TypeName(sourceSheet) <> "Worksheet" And _
        TypeName(sourceArg) <> "PivotCache" Then
        Set [s{bge[ȕݒ] = Nothing
        Exit Function
    End If
    If TypeName(pivotSheet) <> "Worksheet" Then
        Set [s{bge[ȕݒ] = Nothing
        Exit Function
    End If
    Set sourceObj = sourceArg
    Set pivotRng = pivotArg
    If TypeName(sourceSheet) = "Worksheet" Then
        If TypeName(sourceObj) = "Worksheet" Then
            Set sourceRng = sourceSheet.Range("A1").CurrentRegion
        Else
            Set sourceRng = sourceObj
        End If
        Set wb = pivotSheet.Parent
        Set ptCache = wb.PivotCaches.Create(1, sourceRng)
    Else
        Set ptCache = sourceObj
    End If
    If TypeName(pivotRng) = "Worksheet" Then
        Set pivotRng = pivotSheet.Range("A1")
    End If
    pivotSheet.Activate
    Set ptObj = ptCache.CreatePivotTable(pivotRng)
    Set [s{bge[ȕݒ] = ptObj
End Function

' --subPara s{bge[uœx̏Wv\𐶐
Sub [xWv](ptObj, ByVal xItem, ByVal yItem)
    Dim countItem
    countItem = xItem
    If IsNull(xItem) = True Then countItem = yItem
    If IsNull(countItem) = True Then Exit Sub
    ptObj.DisplayNullString = True
    ptObj.NullString = "0"
    If IsNull(xItem) = False Then
        With ptObj.PivotFields(xItem)
            .Orientation = 2
            .LabelRange.Value = .Name
        End With
    End If
    If IsNull(yItem) = False Then
        With ptObj.PivotFields(yItem)
            .Orientation = 1
            .LabelRange.Value = .Name
        End With
    End If
    With ptObj.PivotFields(countItem)
        .Orientation = 4
        .Function = -4112
        .Caption = "x"
    End With
End Sub

' --subPara s{bge[uō\̏Wv\𐶐
Sub [\Wv](ptObj, ByVal xItem, ByVal yItem)
    Dim countItem, percentWay
    countItem = xItem
    percentWay = 6
    If IsNull(xItem) = True Then countItem = yItem
    If IsNull(countItem) = True Then Exit Sub
    If IsNull(xItem) = True Then percentWay = 7
    ptObj.DisplayNullString = True
    ptObj.NullString = "0"
    If IsNull(xItem) = False Then
        With ptObj.PivotFields(xItem)
            .Orientation = 2
            .LabelRange.Value = .Name
        End With
    End If
    If IsNull(yItem) = False Then
        With ptObj.PivotFields(yItem)
            .Orientation = 1
            .LabelRange.Value = .Name
        End With
    End If
    With ptObj.PivotFields(countItem)
        .Orientation = 4
        .Function = -4112
        .Caption = "\"
        .Calculation = percentWay
        .NumberFormat = "0.0%"
    End With
End Sub

' --subPara s{bge[uœxƍ\̏Wv(xA\͉)
Sub [xƍ\Wv](ptObj, ByVal xItem, ByVal yItem)
    m_DegreeAndRate ptObj, xItem, yItem, 2
End Sub

' --subPara s{bge[uœxƍ\̏Wv(xA\͏c)
Sub [xƍ\Wv2](ptObj, ByVal xItem, ByVal yItem)
    m_DegreeAndRate ptObj, xItem, yItem, 1
End Sub

' --subPara s{bgACȅύX
Sub [s{bgACȅύX](fld, itemNames)
    Dim i, j, iName, errorAry(), errorStr
    If TypeName(itemNames) = "String" Then
        itemNames = Split(itemNames)
    End If
    i = 0
    j = -1
    For Each iName In itemNames
        i = i + 1
        On Error Resume Next
        fld.PivotItems(iName).Position = i
        If Err.Number <> 0 Then
            j = j + 1
            ReDim Preserve errorAry(j)
            errorAry(j) = iName
            Err.Clear
        End If
        On Error GoTo 0
    Next
    If j >= 0 Then
        errorStr = "'" & fld.Name & "'ɊỸACe܂: " & _
            Join(errorAry, ", ")
        m_WarningMsg errorStr, "s{bgACȅύX"
    End If
End Sub

' --subPara lPɕϊ(1:^, 2:ۗ, 3:΂Ȃ)
Sub [𕶎ɕϊ](ws, colName, factorNames)
    Dim cell, col, rng, startRow, lastRow, v, i
    If TypeName(ws) <> "Worksheet" Then Exit Sub
    If TypeName(factorNames) = "String" Then
        factorNames = Split(factorNames)
    End If
    Set cell = ws.UsedRange.Find(colName)
    If TypeName(cell) <> "Range" Then Exit Sub
    Set rng = cell.CurrentRegion
    col = cell.Column  ' ڗ̗ԍ
    startRow = cell.Row + 1  ' f[^̍ŏ̍sԍ
    Set cell = [̃Zon](rng)
    lastRow = cell.Row  ' f[^̍ŏIs
    If (lastRow - startRow) < 0 Then Exit Sub
    i = startRow
    Do While i <= lastRow
        v = ws.Cells(i, col).Value
        If v = "" Then v = 0.0
        If TypeName(v) <> "Double" Then Exit Do
        ws.Cells(i, col).Value = factorNames(v)
        i = i + 1
    Loop
End Sub

' --subPara 񓚂̓xWv
Sub [񓚂̓xWv](sourceSheet, newObj, ByVal xItems, ByVal yItem, ByVal itemNames)
    m_MultiAnswer sourceSheet, newObj, xItems, _
        yItem, itemNames, "xWv"
End Sub

' --subPara 񓚂̍\Wv
Sub [񓚂̍\Wv](sourceSheet, newObj, ByVal xItems, ByVal yItem, ByVal itemNames)
    m_MultiAnswer sourceSheet, newObj, xItems, _
        yItem, itemNames, "\Wv"
End Sub

' --subPara 񓚂̓xƍ\Wv
Sub [񓚂̓xƍ\Wv](sourceSheet, newObj, ByVal xItems, ByVal yItem, ByVal itemNames)
    m_MultiAnswer sourceSheet, newObj, xItems, _
        yItem, itemNames, "xƍ\Wv"
End Sub

' --subPara 񓚂̓xƍ\Wv2(xA\䂪c)
Sub [񓚂̓xƍ\Wv2](sourceSheet, newObj, ByVal xItems, ByVal yItem, ByVal itemNames)
    m_MultiAnswer sourceSheet, newObj, xItems, _
        yItem, itemNames, "xƍ\Wv2"
End Sub

' ---- Word֘Å֐ETu[`
' --funcPara hLgJB[hLg]ZbgB
Function [hLgJ](ByVal FileName)
    Dim extName, fname, docName
    FileName = FullPath(FileName)
    extName = m_GetMyExtName(FileName)
    fname = g_fso.GetFileName(FileName)
    If extName <> "doc" And extName <> "docx" And extName <> "docm" And _
        extName <> "dot" And extName <> "dotx" Then
        m_WarningMsg "gqsK: '" & fname & "'", "hLgJ"
        Set [hLgJ] = Nothing
        Exit Function
    End If
    If TypeName([[h]) <> "Application" Then
        On Error Resume Next
        Set [[h] = CreateObject("Word.Application")  ' Word̋N
        If Err.Number <> 0 Then
            m_WarningMsg "[hNł܂.", "hLgJ"
            Set [hLgJ] = Nothing
            Err.Clear
            Exit Function
        Else
            [[h].Visible = True  ' Word̏ߒԂ
        End If
        On Error GoTo 0
    End If
    If m_SameDocumentOpen(FileName) = True Then
        docName = g_fso.GetFileName(FileName)
        m_WarningMsg "łɓ '" & docName & "' JĂ܂.", _
            "hLgJ"
        Set [hLgJ] = Nothing
        Exit Function
    End If
    If g_fso.FileExists(FileName) = True Then
        Set [hLg] = [[h].Documents.Open(FileName)
        m_DocDict.Add [hLg].Name, fname
    Else
        Set [hLg] = [[h].Documents.Add
        m_DocDict.Add [hLg].Name, fname
    End If
    g_sho.AppActivate [hLg].Name & " - Word"
    Set [hLgJ] = [hLg]
End Function

' --subPara [hLg]ʂ̖OŕۑBuOtĕۑvɑ
Sub [hLgʖŕۑ](ByVal FileName)
    Dim extName, fname, rc, oldName, newName
    FileName = FullPath(FileName)
    extName = m_GetMyExtName(FileName)
    fname = g_fso.GetFileName(FileName)
    If extName <> "doc" And extName <> "docx" And extName <> "docm" Then
        m_WarningMsg "gqsK: '" & fname & "'", _
            "hLgʖŕۑ"
        Exit Sub
    End If
    If g_fso.FileExists(FileName) Then
        rc = MsgBox("'" & fname & "' ㏑܂?", vbYesNo+4096, _
            "hLgʖŕۑ")
        If rc <> 6 Then Exit Sub
        g_fso.DeleteFile(FileName)
    End If
    oldName = [hLg].Name
        Select Case extName
        Case "doc"
            [hLg].SaveAs FileName, 11
        Case "docx"
            [hLg].SaveAs FileName, 12
        Case "docm"
            [hLg].SaveAs FileName, 13
        End Select
    newName = [hLg].Name
    If oldName <> newName Then
        m_DocDict.Remove oldName
        m_DocDict.Add newName, newName
    End If
End Sub

' --sub [hLg]ۑBu㏑ۑvɑ
Sub [hLgۑ]
    Dim oldName, newName
    If TypeName([hLg]) <> "Document" Then Exit Sub
    oldName = [hLg].Name
    newName = m_DocDict(oldName)
    If oldName = newName Then
        [[h].DisplayAlerts = False
        [hLg].Save
        [[h].DisplayAlerts = True
    Else  ' VK쐬Ȃ̂ŁuOtĕۑv
        [hLgʖŕۑ] newName
    End If
End Sub

' --subPara w̃hLgBԍ܂̓hLgŎw
Sub [hLgon](ByVal idx)
    Dim doc, docName, documentName
    If IsNull(idx) Or IsEmpty(idx) Or idx = "" Then
        Set doc = [hLg]
    Else
        idx = m_GetDocIndex(idx)
        On Error Resume Next
        Set doc = [[h].Documents(idx)
        If Err.Number <> 0 Then
            Set doc = Nothing
            Err.Clear
        End If
        On Error GoTo 0
    End If
    If TypeName(doc) <> "Document" Then Exit Sub
    docName = doc.Name
    documentName = ""
    If TypeName([hLg]) = "Document" Then _
        documentName = [hLg].Name
    [[h].DisplayAlerts = False
    doc.Close 0
    [[h].DisplayAlerts = True
    If m_DocDict.Exists(docName) = True Then m_DocDict.Remove docName
    If docName = documentName Then
        If [[h].Documents.Count > 0 Then
            Set [hLg] = [[h].ActiveDocument
        Else
            Set [hLg] = Nothing
        End If
    End If
End Sub

' --sub [hLg]
Sub [hLg]
    [hLgon] Null
End Sub

' --sub ׂẴhLg, [hI
Sub [[hI]
    Dim doc
    If TypeName([[h]) <> "Application" Then Exit Sub
    If [[h].Documents.Count > 0 Then
        [[h].DisplayAlerts = False
        [[h].Documents.Close 0
        [[h].DisplayAlerts = True
    End If
    [[h].Quit
    m_DocDict.RemoveAll
End Sub

' --funcPara hLg؂ւBԍ܂̓hLgŎwB
Function [hLg؂ւ](ByVal idx)
    Dim doc
    If TypeName([[h]) <> "Application" Then
        Set [hLg؂ւ] = Nothing
        Exit Function
    End If
    idx = m_GetDocIndex(idx)
    On Error Resume Next
    Set doc = [[h].Documents(idx)
    If Err.Number <> 0 Then
        m_WarningMsg "'" & idx & "': ؂ւł܂.", _
            "hLg؂ւ"
        Set [hLg؂ւ] = Nothing
        Err.Clear
        Exit Function
    End If
    On Error GoTo 0
    If doc.Name <> [hLg].Name Then
        Set [hLg] = doc
    End If
    Set [hLg؂ւ] = [hLg]
End Function

' --funcPara whLg̐擪RangeԂ
Function [hLg̐擪on](docObj)
    Dim doc
    If TypeName(docObj) = "Document" Then
        Set doc = docObj
    Else
        Set doc = [hLg]
    End If
    If TypeName(doc) <> "Document" Then
        Set [hLg̐擪on] = Nothing
        Exit Function
    End If
    Set [hLg̐擪on] = doc.Bookmarks("\StartOfDoc").Range
End Function

' --funcPara [hLg]̐擪RangeԂ
Function [hLg̐擪]()
    Set [hLg̐擪] = [hLg̐擪on](Null)
End Function

' --funcPara whLg̖RangeԂ
Function [hLg̖on](docObj)
    Dim doc
    If TypeName(docObj) = "Document" Then
        Set doc = docObj
    Else
        Set doc = [hLg]
    End If
    If TypeName(doc) <> "Document" Then
        Set [hLg̖on] = Nothing
        Exit Function
    End If
    Set [hLg̖on] = doc.Bookmarks("\EndOfDoc").Range
End Function

' --funcPara [hLg]̖RangeԂ
Function [hLg̖]()
    Set [hLg̖] = [hLg̖on](Null)
End Function

' --subPara WorďxbZ[Wo͂𐧌BTrue, FalsewB
Sub [[ȟx](flag)
    If TypeName([[h]) <> "Application" Then Exit Sub
    [[h].DisplayAlerts = flag
End Sub

' --func [hSelectionIuWFNgԂ
Function Selection()
    If TypeName([[h]) = "Application" Then
        Set Selection = [[h].Selection
    Else
        Set Selection = Nothing
    End If
End Function

' --subPara whLg(ZNV)̗pTCYݒ
  ' 2: A3 B3 A4 B4 A5 B5 A6 B6 nKL ^[ [K
Sub [pTCYon](targetObj, ByVal key)
    Dim target, sizeDict, height, width, landscape, w
    If TypeName(targetObj) = "Document" Or _
        TypeName(targetObj) = "Section" Then
        Set target = targetObj
    Else
        Set target = [hLg]
    End If
    If TypeName(target) <> "Document" And _
        TypeName(target) <> "Section" Then Exit Sub
        ' pTCYɊւ鎫ݒ
    Set sizeDict = WScript.CreateObject("Scripting.Dictionary")
    sizeDict.Add "B3", Array(364, 515)
    sizeDict.Add "A3", Array(297, 420)
    sizeDict.Add "B4", Array(257, 364)
    sizeDict.Add "A4", Array(210, 297)
    sizeDict.Add "B5", Array(182, 257)
    sizeDict.Add "A5", Array(148, 210)
    sizeDict.Add "B6", Array(128, 182)
    sizeDict.Add "A6", Array(105, 148)
    sizeDict.Add "nKL", Array(100, 148)
    sizeDict.Add "^[", Array(215.9, 279.4)
    sizeDict.Add "[K", Array(215.9, 355.6)
    key = UCase(key)
    landscape = False
    If Right(key, 1) = "L" Then
        landscape = True
        key = Left(key, Len(key)-1)
    End If
    If key = "͂" Or key = "t" Then key = "nKL"
    If sizeDict.Exists(key) = False Then Exit Sub
    width = sizeDict(key)(0)
    height = sizeDict(key)(1)
    If landscape = True Then
        w = width
        width = height
        height = w
    End If
    With target.PageSetup
        .PageWidth = [[h].MillimetersToPoints(width)
        .PageHeight = [[h].MillimetersToPoints(height)
        .FooterDistance = [[h].MillimetersToPoints(17.5)
        .HeaderDistance = [[h].MillimetersToPoints(15.0)
        If landscape = True Then
            .Orientation = 1
        Else
            .Orientation = 0
        End If
    End With
End Sub

' --subPara [hLg]̗pTCYݒ
Sub [pTCY](ByVal key)
    [pTCYon] Null, key
End Sub

' --subPara whLg(ZNV)̕ƍsݒ
Sub [ƍson](targetObj, ByVal chars, ByVal lines)
    Dim target
    If TypeName(targetObj) = "Document" Or _
        TypeName(targetObj) = "Section" Then
        Set target = targetObj
    Else
        Set target = [hLg]
    End If
    If TypeName(target) <> "Document" And _
        TypeName(target) <> "Section" Then Exit Sub
    If TypeName(chars) <> "Integer" Then chars = 0
    If TypeName(lines) <> "Integer" Then lines = 0
    With target.PageSetup
        If chars = 0 And lines = 0 Then
            .LayoutMode = 0  ' W̕g
        ElseIf chars > 0 Then
            .LayoutMode = 1  ' ƍsw
            .CharsLine = chars
            If lines > 0 Then  ' 1y[W̍s
                .LinesPage = lines
            End If
        ElseIf lines > 0 Then
            .LayoutMode = 2  ' sw
            .LinesPage = lines
        End If
    End With
End Sub

' --subPara [hLg]̕ƍsݒ
Sub [ƍs](ByVal chars, ByVal lines)
    [ƍson] Null, chars, lines
End Sub

' --subPara whLg(ZNV)̒igݒ
Sub [igon](targetObj, ByVal textCol)
    Dim target, sect
    If TypeName(targetObj) = "Document" Or _
        TypeName(targetObj) = "Section" Then
        Set target = targetObj
    Else
        Set target = [hLg]
    End If
    If TypeName(target) <> "Document" And _
        TypeName(target) <> "Section" Then Exit Sub
    If TypeName(textCol) <> "Integer" Then Exit Sub
    If textCol < 1 Then Exit Sub
    If TypeName(target) = "Document" Then
        For Each sect In target.Sections
            sect.PageSetup.TextColumns.SetCount(textCol)
            sect.PageSetup.TextColumns.EvenlySpaced = True 'iԊuϓ
            sect.PageSetup.TextColumns.LineBetween = True ' E
        Next
    Else
        target.PageSetup.TextColumns.SetCount(textCol)
        target.PageSetup.TextColumns.EvenlySpaced = True 'iԊuϓ
        target.PageSetup.TextColumns.LineBetween = True ' E
    End If
End Sub

' --subPara [hLg]̒igݒ
Sub [ig](ByVal textCol)
    [igon] Null, textCol
End Sub

' --subPara whLg(ZNV)̃y[W؍sݒ
Sub [y[Wԍon](targetObj, ByVal pageFlag)
    Dim target, sect, hd_ft, rng
    If TypeName(targetObj) = "Document" Or _
        TypeName(targetObj) = "Section" Then
        Set target = targetObj
    Else
        Set target = [hLg]
    End If
    If TypeName(target) <> "Document" And _
        TypeName(target) <> "Section" Then Exit Sub
    If TypeName(target) = "Document" Then
        For Each sect In target.Sections  ' ̃y[Wԍ
            For Each hd_ft In sect.Footers
                hd_ft.Range.Delete
            Next
        Next
        If pageFlag = True Then
            For Each sect In target.Sections
                Set rng = sect.Footers(1).Range  ' tb^[̈
                rng.Text = "p/n"  ' ̕
                rng.Fields.Add rng.Words(1), -1, "PAGE", False
                rng.Fields.Add rng.Words(3), -1, "NUMPAGES", False
                rng.ParagraphFormat.Alignment = 1  ' 
            Next
        End If
    Else
        For Each hd_ft In target.Footers
            hd_ft.Range.Delete
        Next
        If pageFlag = True Then
            Set rng = target.Footers(1).Range  ' tb^[̈
            rng.Text = "p/n"  ' ̕
            rng.Fields.Add rng.Words(1), -1, "PAGE", False
            rng.Fields.Add rng.Words(3), -1, "NUMPAGES", False
            rng.ParagraphFormat.Alignment = 1  ' 
        End If
    End If
End Sub

' --subPara [hLg]̃y[W؍sݒ
Sub [y[Wԍ](ByVal pageFlag)
    [y[Wԍon] Null, pageFlag
End Sub

' ---- DataBase(accdb, mdb, xlsx, xls)֘A
' --funcPara f[^x[XJB[f[^x[X](ConnectionObject)ZbgB
Function [f[^x[XJ](ByVal DbName)
    Set [f[^x[X] = m_DbOpen(DbName)
    Set [f[^x[XJ] = [f[^x[X]
End Function

' --funcPara f[^x[X̃e[uDictionaryŕԂ
  ' ɂ ConnectionObjectw
Function [f[^x[X̕\̈ꗗon](ConnObj, ByVal typeAry)
    Dim CAT, Tbl, TblDict, typeDict, x
    If TypeName(ConnObj) <> "Connection" Then
        Set ConnObj = [f[^x[X]
    End If
    If TypeName(ConnObj) <> "Connection" Then
        Set [f[^x[X̕\̈ꗗon] = Nothing
    End If
    If ConnObj.State = 0 Then
        Set [f[^x[X̕\̈ꗗon] = Nothing
    End If
    If TypeName(typeAry) = "String" Then
        typeAry = Split(typeAry)
    ElseIf TypeName(typeAry) <> "Variant()" Then
        typeAry = Array()
    End If
    Set typeDict = CreateObject("Scripting.Dictionary")
    If UBound(typeAry) >= 0 Then
        For Each x In typeAry
            typeDict.Add x, 1
        Next
    End If
    Set CAT = CreateObject("ADOX.Catalog")
    CAT.ActiveConnection = ConnObj
    Set TblDict = CreateObject("Scripting.Dictionary")
    For Each Tbl In CAT.Tables
        If typeDict.Exists(Tbl.Type) Or UBound(typeAry) < 0 Then
            TblDict.Add Tbl.Name, Array(Tbl.Name, Tbl.Type, _
                Tbl.DateCreated, Tbl.DateModified)
        End If
    Next
    Set [f[^x[X̕\̈ꗗon] = TblDict
End Function

' --func [f[^x[X]̃e[uDictionaryŕԂ
Function [f[^x[X̕\̈ꗗ](ByVal typeAry)
    Set [f[^x[X̕\̈ꗗ] = [f[^x[X̕\̈ꗗon](Null, typeAry)
End Function

' --subPara f[^x[XBConnectionObjectwB
Sub [f[^x[Xon](ConnObj)
    If TypeName(ConnObj) <> "Connection" Then
        Set ConnObj = [f[^x[X]
    End If
    If TypeName(ConnObj) <> "Connection" Then Exit Sub
    If ConnObj.State = 1 Then ConnObj.Close
        Set ConnObj = Nothing
    If TypeName([f[^x[X]) = "Connection" Then
        If [f[^x[X].State = 0 Then
            Set [f[^x[X] = Nothing
        End If
    End If
End Sub

' --sub [f[^x[X]
Sub [f[^x[X]
    [f[^x[Xon] Null
End Sub

' --subPara f[^x[XƂɊ܂܂table쐬
Sub [f[^x[X̕\쐬on](ConnObj, ByVal TableName, ByVal TypeStr)
    Dim TblDict, sql
    If TypeName(ConnObj) <> "Connection" Then
        Set ConnObj = [f[^x[X]
    End If
    If TypeName(ConnObj) <> "Connection" Then Exit Sub
    If ConnObj.State = 0 Then Exit Sub
    Set TblDict = [f[^x[X̕\̈ꗗon](ConnObj, Null)
    If TypeName(TblDict) = "Dictionary" Then
        If TblDict.Exists(TableName) = True Then
            m_WarningMsg "'" & TableName & "' ɑ݂܂.", _
                "f[^x[X̕\쐬"
            Exit Sub
        End If
    End If
    sql = "create table " & TableName & " (" & TypeStr & ");"
    ConnObj.Execute(sql)  ' e[u쐬
End Sub

' --subPara [f[^x[X]Ɋ܂܂table쐬
Sub [f[^x[X̕\쐬](ByVal TableName, ByVal TypeStr)
    [f[^x[X̕\쐬on] Null, TableName, TypeStr
End Sub

' --subPara f[^x[XɊ܂܂table폜
Sub [f[^x[X̕\폜on](ConnObj, ByVal TableName)
    Dim TblDict, DbName, sql
    If TypeName(ConnObj) <> "Connection" Then
        Set ConnObj = [f[^x[X]
    End If
    If TypeName(ConnObj) <> "Connection" Then Exit Sub
    If ConnObj.State = 0 Then Exit Sub
    DbName = g_fso.GetFileName(ConnObj.Properties("Data Source"))
    Set TblDict = [f[^x[X̕\̈ꗗon](ConnObj, Null)
    If TypeName(TblDict) <> "Dictionary" Then
        m_WarningMsg "'" & DbName & "' ̏擾ł܂.", _
            "f[^x[X̕\폜"
        Exit Sub
    End If
    If TblDict.Exists(TableName) = False Then
        m_WarningMsg "'" & TableName & "' ݂܂.", _
            "f[^x[X̕\폜"
        Exit Sub
    End If
    sql = "DROP TABLE [" & TableName & "];"
    ConnObj.Execute(sql)
End Sub

' --subPara [f[^x[X]Ɋ܂܂table폜
Sub [f[^x[X̕\폜](ByVal TableName)
    [f[^x[X̕\폜on] Null, TableName
End Sub

' --subPara z̔zf[^x[Xɒǉ̌`Ŏ荞
Sub [z񂩂f[^x[Xon](ConnObj, ByVal TableName, rsAry)
    Dim DbTbl, DbRS, i, j, v
    If TypeName(ConnObj) <> "Connection" Then
        Set ConnObj = [f[^x[X]
    End If
    If TypeName(ConnObj) <> "Connection" Then Exit Sub
    If ConnObj.State = 0 Then Exit Sub
    If [f[^x[X̕\̈ꗗon](ConnObj, Null).Exists(TableName) = False Then
        m_WarningMsg "'" & TableName & "' Ƃe[u݂܂.", _
            "f[^x[Xɔz荞"
        Exit Sub
    End If
    DbTbl = TableName
    If Left(DbTbl, 1) <> "[" Then
        DbTbl = "[" & TableName & "]"
    End If
    Set DbRS = CreateObject("ADODB.Recordset")
    DbRS.Open DbTbl, ConnObj, 0, 2, 2
    For i = 0 To UBound(rsAry)
        DbRS.AddNew
        For j = 0 To UBound(rsAry(i))
            v = rsAry(i)(j)
            If IsEmpty(v) = False And IsNull(v) = False And v <> "" Then
                DbRS.Fields(j).Value = v
            End If
        Next
        DbRS.Update
    Next
    DbRS.Close
End Sub

' --subPara z̔z[f[^x[X]ɒǉ̌`Ŏ荞
Sub [z񂩂f[^x[X](ByVal TableName, rsAry)
    [z񂩂f[^x[Xon] Null, TableName, rsAry
End Sub

' --subPara f[^x[Xcsvǉ̌`Ŏ荞
Sub [csvf[^x[Xon](ConnObj, ByVal TableName, ByVal CsvName, ByVal hdr)
    Dim DbTbl, DbRS
    Dim CsvPath, CsvFolder, CsvConnObj, CsvConnStr, CsvTbl, CsvRS, i
    If TypeName(ConnObj) <> "Connection" Then
        Set ConnObj = [f[^x[X]
    End If
    If TypeName(ConnObj) <> "Connection" Then Exit Sub
    If ConnObj.State = 0 Then Exit Sub
    If [f[^x[X̕\̈ꗗon](ConnObj, Null).Exists(TableName) = False Then
        m_WarningMsg "'" & TableName & "' Ƃe[u݂܂.", _
            "f[^x[Xcsv荞"
        Exit Sub
    End If
    CsvPath = FullPath(CsvName)
    If (g_fso.FileExists(CsvPath) = False) Then
        m_WarningMsg "'" & CsvName & "' ݂܂.", _
            "f[^x[Xcsv荞"
        Exit Sub
    End If
        ' CSṼI[v葱
    CsvFolder = g_fso.getParentFolderName(CsvPath)
    If Right(CsvFolder, 1) <> "\" Then
        CsvFolder = CsvFolder & "\"
    End If
    CsvConnStr = "Provider=Microsoft.ACE.OLEDB.12.0;" & _
        "Data Source=""" & CsvFolder & """;" & _
        "Extended Properties=""Text;HDR=" & hdr & ";FMT=Delimited"";"
    Set CsvConnObj = CreateObject("ADODB.Connection")
    CsvConnObj.Open CsvConnStr
        ' R[h̓ǂݍ݂Ǝ荞
    CsvTbl = CsvName
    If Left(CsvTbl, 1) <> "[" Then
        CsvTbl = "[" & CsvName & "]"
    End If
    Set CsvRS = CreateObject("ADODB.Recordset")
    CsvRS.Open CsvTbl, CsvConnObj, 0, 1, 2
    DbTbl = TableName
    If Left(DbTbl, 1) <> "[" Then
        DbTbl = "[" & TableName & "]"
    End If
    Set DbRS = CreateObject("ADODB.Recordset")
    DbRS.Open DbTbl, ConnObj, 0, 2, 2
    Do Until CsvRS.EOF
        DbRS.AddNew
        For i = 0 To (CsvRS.Fields.Count-1)
            DbRS.Fields(i).Value = CsvRS.Fields(i).Value
        Next
        DbRS.Update
        CsvRS.MoveNext
    Loop
    CsvRS.Close
    CsvConnObj.Close
    DbRS.Close
End Sub

' --subPara [f[^x[X]csvǉ̌`Ŏ荞
Sub [csvf[^x[X](ByVal TableName, ByVal CsvName, ByVal hdr)
    [csvf[^x[Xon] Null, TableName, CsvName, hdr
End Sub

' --funcPara sqlɂw̃f[^x[XǂݍŔz̔zƂĕԂ
Function [f[^x[Xzon](ConnObj, ByVal sqlStr)
    Dim rs, ary(), rowCount, row(), i
    If TypeName(ConnObj) <> "Connection" Then
        Set ConnObj = [f[^x[X]
    End If
    If TypeName(ConnObj) <> "Connection" Then
        [f[^x[Xzon] = Array()
        Exit Function
    End If
    If ConnObj.State = 0 Then
        [f[^x[Xzon] = Array()
        Exit Function
    End If
    Set rs = CreateObject("ADODB.Recordset")
    On Error Resume Next
    rs.Open sqlStr, ConnObj, 0, 1  ' OցAǎp
    If Err.Number <> 0 Then
        Err.Clear
        [f[^x[Xzon] = Array()
        Exit Function
    End If
    On Error GoTo 0
    ReDim row(rs.Fields.Count-1)
    For i = 0 To (rs.Fields.Count-1)
        row(i) = rs.Fields(i).Name
    Next
    ReDim Preserve ary(0)
    ary(0) = row
    rowCount = 0
    Do Until rs.EOF
        ReDim row(rs.Fields.Count-1)
        For i = 0 To (rs.Fields.Count-1)
            row(i) = rs.Fields(i).Value
        Next
        rowCount = rowCount + 1
        ReDim Preserve ary(rowCount)
        ary(rowCount) = row
        rs.MoveNext
    Loop
    rs.Close
    [f[^x[Xzon] = ary
End Function

' --funcPara sqlɂ[f[^x[X]ǂݍŔz̔zƂĕԂ
Function [f[^x[Xz](ByVal sqlStr)
    [f[^x[Xz] = _
        [f[^x[Xzon](Null, sqlStr)
End Function

' --funcPara SQLߕ̒̕uB%0, %1, %2, cc zɑĒu
Function SqlReplace(ByVal s, ByVal ary)
    Dim i, val
    If TypeName(ary) <> "Variant()" Then
        SqlReplace = s
        Exit Function
    End If
    For i = UBound(ary) To 0 Step -1
        val = ary(i)
        If TypeName(val) = "String" Then
            val = Replace(val, "%", Chr(7))
            val = Replace(val, "'", "''")
        End If
        s = Replace(s, "'%" & i & "'", "'" & val & "'")
    Next
    For i = UBound(ary) To 0 Step -1
        val = ary(i)
        If TypeName(val) = "String" Then
            val = Replace(val, "%", Chr(7))
        End If
        s = Replace(s, "%" & i, val)
    Next
    s = Replace(s, Chr(7), "%")
    SqlReplace = s
End Function

' --funcPara SQLsBConnectionObjectwB
Function [sqlson](ConnObj, ByVal sql)
    Set [sqlson] = [sqls%on](ConnObj, sql, Null)
End Function

' --funcPara [f[^x[X]ɂSQLsB
Function [sqls](ByVal sql)
    Set [sqls] = [sqls%on](Null, sql, Null)
End Function

' --funcPara SQLsBConnectionObjectwB%0, %1, cc 
Function [sqls%on](ConnObj, ByVal sql, ByVal ary)
    Dim FileName, fileObj
    If TypeName(ConnObj) <> "Connection" Then
        Set ConnObj = [f[^x[X]
    End If
    If TypeName(ConnObj) <> "Connection" Then
        Set [sqls%on] = Nothing
        Exit Function
    End If
    If TypeName(ary) = "String" Then
        ary = Split(ary)
    End If
    FileName = FullPath(sql)
    If g_fso.FileExists(FileName) = True Then
        Set fileObj = g_fso.OpenTextFile(FileName)
        sql = fileObj.ReadAll()
        fileObj.Close
    End If
    sql = SqlReplace(sql, ary)
    On Error Resume Next
    Set [sqls%on] = ConnObj.Execute(sql)
    If Err.Number <> 0 Then
        Set [sqls%on] = Nothing
        Set fileObj = g_fso.OpenTextFile(warningFile, 8, True)
        fileObj.Write "SQL: " & sql & vbNewLine & _
            "Error: " & Err.Description & vbNewLine & vbNewLine
        fileObj.Close
        Set fileObj = Nothing
        Err.Clear
    End If
    On Error GoTo 0
End Function

' --funcPara [f[^x[X]ɂSQLsB%0, %1, cc 
Function [sqls%](ByVal sql, ByVal ary)
    Set [sqls%] = [sqls%on](Null, sql, ary)
End Function

' ---- ̑̃Tu[`E֐
' --funcPara t@CEtH_̐΃pXԂ
Function FullPath(ByVal fname)
    FullPath = g_fso.GetAbsolutePathName(fname)
End Function

' --funcPara ChJ[hɊYt@CzŕԂ
Function [t@C̈ꗗ](ByVal wildName)
    Dim fileList(), count, fname, dname, fname2, cname, ptn, f, ch
    Dim regEx, Match, Matches, RetStr
    count = -1
    wildName = FullPath(wildName)
    If InStr(wildName, "*") = 0 And InStr(wildName, "?") = 0 Then
        If g_fso.FolderExists(wildName) = True Then
            wildName = wildName & "\*.*"
        ElseIf g_fso.FileExists(wildName) = True Then
            count = count + 1
            ReDim Preserve fileList(count)
            fileList(count) = wildName
            [t@C̈ꗗ] = fileList
            Exit Function
        Else
            [t@C̈ꗗ] = Array()
            Exit Function
        End If
    End If
    fname = g_fso.GetFileName(wildName)
    dname = g_fso.GetParentFolderName(wildName)
    If g_fso.FolderExists(dname) = False Then
        [t@C̈ꗗ] = Array()
        Exit Function
    End If
    cname = g_fso.GetFolder(".")
    If Right(fname, 3) = "*.*" Then
        ptn = Left(fname, Len(fname)-2)
    ElseIf Right(fname, 2) = ".*" Then
        ptn = Left(fname, Len(fname)-2) & "*"
    Else
        ptn = fname
    End If
    ptn = Replace(ptn, "\", Chr(7) & Chr(7))
    For Each ch In Split(".,(,),[,],{,},^,$,+,|", ",")
        ptn = Replace(ptn, ch, Chr(7) & ch)
    Next
    ptn = Replace(ptn, "*", ".*")
    ptn = Replace(ptn, "?", ".?")
    ptn = Replace(ptn, Chr(7), "\")
    ptn = "^" & ptn & "$"
    Set regEx = New RegExp
    regEx.Pattern = ptn
    regEx.Global = True
    regEx.IgnoreCase = True
        ' tH_̃t@CƃChJ[hEp^[Ƃ̏ƍo
    For Each f In g_fso.GetFolder(dname).Files
        Set Matches = regEx.Execute(f.Name)
        If Matches.Count > 0 Then
            Set Match = Matches(0)
            If dname <> cname Then
                count = count + 1
                ReDim Preserve fileList(count)
                fname2 = Match.Value
                If Right(dname, 1) <> "\" Then fname2 = "\" & fname2
                fileList(count) = dname & fname2
            Else
                count = count + 1
                ReDim Preserve fileList(count)
                fileList(count) = Match.Value
            End If
        End If
    Next
    If count >= 0 Then
        [t@C̈ꗗ] = fileList
    Else
        [t@C̈ꗗ] = Array()
    End If
End Function

' --funcPara Yt@C\[gĕԂ
  ' Q: O 쐬 XV TCY
Function [t@C̈ꗗ\[g](ByVal wildName, ByVal items)
    Dim fileList, fname, fInfo, itemAry, dict, key, keys, tAry(), i
    fileList = [t@C̈ꗗ](wildName)
    If UBound(fileList) < 1 Then
        [t@C̈ꗗ\[g] = fileList
        Exit Function
    End If
    If TypeName(items) <> "String" Then items = "O"
    If items = "" Then items = "O"
    If InStr(items, "O") = 0 Then items = items & " O"
    itemAry = Split(items)
    ReDim tAry(UBound(itemAry))
    Set dict = CreateObject("Scripting.Dictionary")
    For Each fname In fileList
        Set fInfo = g_fso.GetFile(fname)
        For i = 0 To UBound(itemAry)
            Select Case itemAry(i)
            Case "O"
                tAry(i) = g_fso.GetFileName(fname)
            Case "쐬"
                tAry(i) = fInfo.DateCreated
            Case "XV"
                tAry(i) = fInfo.DateLastModified
            Case "TCY"
                tAry(i) = Right("0000000000" & fInfo.Size, 10)
            End Select
        Next
        key = Join(tAry, vbTab)
        dict.Add key, fname
    Next
    keys = [z\[g](dict.Keys)
    ReDim tAry(UBound(keys))
    For i = 0 To UBound(keys)
        tAry(i) = dict(keys(i))
    Next
    [t@C̈ꗗ\[g] = tAry
End Function

' --subPara Ỹt@C̒gɂĕ̒us
Sub [t@C̕u](ByVal wildName, ByVal oldStr, ByVal newStr)
    Dim FileName, msg, count, dname, logFile, fileObj
    msg = "* '" & oldStr & "'  '" & newStr & "'" & vbNewLine
    count = 0
    dname = g_fso.GetParentFolderName(FullPath(wildName))
    If Right(dname, 1) = "\" Then dname = Left(dname, Len(dname)-1)
    logFile = dname & "\log(t@C̕u).txt"
    For Each FileName In [t@C̈ꗗ](wildName)
        msg = msg & m_FileSubstitute(FileName, oldStr, newStr) & vbNewLine
        count = count + 1
    Next
    If count = 0 Then
        msg = msg & "Ỹt@C݂܂ł." & vbNewLine
    End If
    msg = msg & vbNewLine
    Set fileObj = g_fso.OpenTextFile(logFile, 8, True)
    fileObj.Write msg
    fileObj.Close
    Set fileObj = Nothing
End Sub

' --subPara t@C݂΍폜
Sub [t@C폜](ByVal FileName)
    If g_fso.FileExists(FileName) Then g_fso.DeleteFile(FileName)
End Sub

' --funcPara t@C݂邩ǂ̊mFB߂l True, False
Function [t@C](ByVal FileName)
    [t@C] = g_fso.FileExists(FileName)
End Function

' --funcPara tH_݂邩ǂ̊mFB߂l True, False
Function [tH_](ByVal FileName)
    [tH_] = g_fso.FolderExists(FileName)
End Function

' --funcPara z\[g
Function [z\[g](ary)
    Dim myArray, elm, ary2
    Set myArray = CreateObject("System.Collections.ArrayList")
    For Each elm In ary
        myArray.Add elm
    Next
    myArray.Sort
    ary2 = myArray.ToArray()
    Set myArray = Nothing
    [z\[g] = ary2
End Function

' --funcPara z̕т𔽓]
Function [z𔽓]](ary)
    Dim rAry(), i, li
    li = UBound(ary)
    If li < 0 Then
        [z𔽓]] = Array()
        Exit Function
    End If
    ReDim rAry(li)
    For i = 0 To li
        rAry(li - i) = ary(i)
    Next
    [z𔽓]] = rAry
End Function

